org.apache.ignite.internal.binary

## Class BinaryReaderExImpl

- java.lang.Object
- - org.apache.ignite.internal.binary.BinaryReaderExImpl

All Implemented Interfaces:
  DataInput, ObjectInput, AutoCloseable, BinaryRawReader, BinaryReader, BinaryRawReaderEx, BinaryReaderHandlesHolder

    public class BinaryReaderExImpl
    extends Object
    implements BinaryReader, BinaryRawReaderEx, BinaryReaderHandlesHolder, ObjectInput

Binary reader implementation.

### Constructor Summary

Constructors
Constructor and Description
`BinaryReaderExImpl(BinaryContext ctx, BinaryInputStream in, ClassLoader ldr, BinaryReaderHandles hnds, boolean forUnmarshal)` Constructor.
`BinaryReaderExImpl(BinaryContext ctx, BinaryInputStream in, ClassLoader ldr, BinaryReaderHandles hnds, boolean skipHdrCheck, boolean forUnmarshal)` Constructor.
`BinaryReaderExImpl(BinaryContext ctx, BinaryInputStream in, ClassLoader ldr, boolean forUnmarshal)` Constructor.

### Method Summary

Methods
`int` `available()`
`void` `close()`
`boolean` `findFieldByName(String name)` Try finding the field by name.
`Object` `getHandle(int pos)` Get handle.
`BinarySchema` `getOrCreateSchema()` Get or create object schema.
`BinaryReaderHandles` `handles()` Get all handles.
`BinaryInputStream` `in()`
`BinaryRawReader` `rawReader()` Gets raw reader.
`int` `read()`
`int` `read(byte[] b)`
`int` `read(byte[] b, int off, int len)`
`boolean` `readBoolean()`
`boolean` `readBoolean(String fieldName)`
`boolean[]` `readBooleanArray()`
`boolean[]` `readBooleanArray(String fieldName)`
`byte` `readByte()`
`byte` `readByte(String fieldName)`
`byte[]` `readByteArray()`
`byte[]` `readByteArray(String fieldName)`
`char` `readChar()`
`char` `readChar(String fieldName)`
`char[]` `readCharArray()`
`char[]` `readCharArray(String fieldName)`
`<T> Collection<T>` `readCollection()`
`<T> Collection<T>` `readCollection(BinaryCollectionFactory<T> factory)`
`<T> Collection<T>` `readCollection(String fieldName)`
`<T> Collection<T>` `readCollection(String fieldName, BinaryCollectionFactory<T> factory)`
`Date` `readDate()`
`Date` `readDate(String fieldName)`
`Date[]` `readDateArray()`
`Date[]` `readDateArray(String fieldName)`
`BigDecimal` `readDecimal()`
`BigDecimal` `readDecimal(String fieldName)`
`BigDecimal[]` `readDecimalArray()`
`BigDecimal[]` `readDecimalArray(String fieldName)`
`double` `readDouble()`
`double` `readDouble(String fieldName)`
`double[]` `readDoubleArray()`
`double[]` `readDoubleArray(String fieldName)`
`<T extends Enum<?>> T` `readEnum()`
`<T extends Enum<?>> T` `readEnum(String fieldName)`
`<T extends Enum<?>> T[]` `readEnumArray()`
`<T extends Enum<?>> T[]` `readEnumArray(String fieldName)`
`float` `readFloat()`
`float` `readFloat(String fieldName)`
`float[]` `readFloatArray()`
`float[]` `readFloatArray(String fieldName)`
`void` `readFully(byte[] b)`
`void` `readFully(byte[] b, int off, int len)`
`int` `readInt()`
`int` `readInt(String fieldName)`
`int[]` `readIntArray()`
`int[]` `readIntArray(String fieldName)`
`String` `readLine()`
`long` `readLong()`
`long` `readLong(String fieldName)`
`long[]` `readLongArray()`
`long[]` `readLongArray(String fieldName)`
`<K,V> Map<K,V>` `readMap()`
`<K,V> Map<K,V>` `readMap(BinaryMapFactory<K,V> factory)`
`<K,V> Map<K,V>` `readMap(String fieldName)`
`<K,V> Map<K,V>` `readMap(String fieldName, BinaryMapFactory<K,V> factory)`
`Object` `readObject()`
`<T> T` `readObject(String fieldName)`
`Object[]` `readObjectArray()`
`Object[]` `readObjectArray(String fieldName)`
`Object` `readObjectDetached()`
`short` `readShort()`
`short` `readShort(String fieldName)`
`short[]` `readShortArray()`
`short[]` `readShortArray(String fieldName)`
`String` `readString()`
`String` `readString(String fieldName)`
`String[]` `readStringArray()`
`String[]` `readStringArray(String fieldName)`
`Timestamp` `readTimestamp()`
`Timestamp` `readTimestamp(String fieldName)`
`Timestamp[]` `readTimestampArray()`
`Timestamp[]` `readTimestampArray(String fieldName)`
`int` `readUnsignedByte()`
`int` `readUnsignedShort()`
`String` `readUTF()`
`UUID` `readUuid()`
`UUID` `readUuid(String fieldName)`
`UUID[]` `readUuidArray()`
`UUID[]` `readUuidArray(String fieldName)`
`void` `setHandle(Object obj, int pos)` Set handle.
`long` `skip(long n)`
`int` `skipBytes(int n)`
`Object` `unmarshal(int offset)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### BinaryReaderExImpl

    public BinaryReaderExImpl(BinaryContext ctx,
                      BinaryInputStream in,
                      ClassLoader ldr,
                      boolean forUnmarshal)

Constructor.

Parameters:
  `ctx` - Context.
  `in` - Input stream.
  `ldr` - Class loader.
  `forUnmarshal` - `True` if reader is needed to unmarshal object.

#### BinaryReaderExImpl

    public BinaryReaderExImpl(BinaryContext ctx,
                      BinaryInputStream in,
                      ClassLoader ldr,
                      @Nullable
                      BinaryReaderHandles hnds,
                      boolean forUnmarshal)

Constructor.

Parameters:
  `ctx` - Context.
  `in` - Input stream.
  `ldr` - Class loader.
  `hnds` - Context.
  `forUnmarshal` - `True` if reader is need to unmarshal object.

#### BinaryReaderExImpl

    public BinaryReaderExImpl(BinaryContext ctx,
                      BinaryInputStream in,
                      ClassLoader ldr,
                      @Nullable
                      BinaryReaderHandles hnds,
                      boolean skipHdrCheck,
                      boolean forUnmarshal)

Constructor.

Parameters:
  `ctx` - Context.
  `in` - Input stream.
  `ldr` - Class loader.
  `hnds` - Context.
  `skipHdrCheck` - Whether to skip header check.
  `forUnmarshal` - `True` if reader is need to unmarshal object.

### Method Detail

#### in

    public BinaryInputStream in()

Returns:
  Input stream.

#### unmarshal

    public Object unmarshal(int offset)
                     throws BinaryObjectException

Parameters:
  `offset` - Offset in the array.
Returns:
  Unmarshalled value.
Throws:
  `BinaryObjectException` - In case of error.

#### setHandle

    public void setHandle(Object obj,
                 int pos)

Set handle.

Specified by:
  `setHandle` in interface `BinaryReaderHandlesHolder`
Parameters:
  `obj` - Object.
  `pos` - Position.

#### getHandle

    public Object getHandle(int pos)

Get handle.

Specified by:
  `getHandle` in interface `BinaryReaderHandlesHolder`
Parameters:
  `pos` - Position.
Returns:
  Handle.

#### handles

    public BinaryReaderHandles handles()

Get all handles.

Specified by:
  `handles` in interface `BinaryReaderHandlesHolder`
Returns:
  Handles.

#### readByte

    public byte readByte(String fieldName)
                  throws BinaryObjectException

Specified by:
  `readByte` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Byte value.
Throws:
  `BinaryObjectException` - In case of error.

#### readByte

    public byte readByte()
                  throws BinaryObjectException

Specified by:
  `readByte` in interface `DataInput`
Specified by:
  `readByte` in interface `BinaryRawReader`
Returns:
  Byte value.
Throws:
  `BinaryObjectException` - In case of error.

#### readByteArray

    @Nullable
    public byte[] readByteArray(String fieldName)
                         throws BinaryObjectException

Specified by:
  `readByteArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Byte array.
Throws:
  `BinaryObjectException` - In case of error.

#### readByteArray

    @Nullable
    public byte[] readByteArray()
                         throws BinaryObjectException

Specified by:
  `readByteArray` in interface `BinaryRawReader`
Returns:
  Byte array.
Throws:
  `BinaryObjectException` - In case of error.

#### readBoolean

    public boolean readBoolean(String fieldName)
                        throws BinaryObjectException

Specified by:
  `readBoolean` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Boolean value.
Throws:
  `BinaryObjectException` - In case of error.

#### readBoolean

    public boolean readBoolean()
                        throws BinaryObjectException

Specified by:
  `readBoolean` in interface `DataInput`
Specified by:
  `readBoolean` in interface `BinaryRawReader`
Returns:
  Boolean value.
Throws:
  `BinaryObjectException` - In case of error.

#### readBooleanArray

    @Nullable
    public boolean[] readBooleanArray(String fieldName)
                               throws BinaryObjectException

Specified by:
  `readBooleanArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Boolean array.
Throws:
  `BinaryObjectException` - In case of error.

#### readBooleanArray

    @Nullable
    public boolean[] readBooleanArray()
                               throws BinaryObjectException

Specified by:
  `readBooleanArray` in interface `BinaryRawReader`
Returns:
  Boolean array.
Throws:
  `BinaryObjectException` - In case of error.

#### readShort

    public short readShort(String fieldName)
                    throws BinaryObjectException

Specified by:
  `readShort` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Short value.
Throws:
  `BinaryObjectException` - In case of error.

#### readShort

    public short readShort()
                    throws BinaryObjectException

Specified by:
  `readShort` in interface `DataInput`
Specified by:
  `readShort` in interface `BinaryRawReader`
Returns:
  Short value.
Throws:
  `BinaryObjectException` - In case of error.

#### readShortArray

    @Nullable
    public short[] readShortArray(String fieldName)
                           throws BinaryObjectException

Specified by:
  `readShortArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Short array.
Throws:
  `BinaryObjectException` - In case of error.

#### readShortArray

    @Nullable
    public short[] readShortArray()
                           throws BinaryObjectException

Specified by:
  `readShortArray` in interface `BinaryRawReader`
Returns:
  Short array.
Throws:
  `BinaryObjectException` - In case of error.

#### readChar

    public char readChar(String fieldName)
                  throws BinaryObjectException

Specified by:
  `readChar` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Char value.
Throws:
  `BinaryObjectException` - In case of error.

#### readChar

    public char readChar()
                  throws BinaryObjectException

Specified by:
  `readChar` in interface `DataInput`
Specified by:
  `readChar` in interface `BinaryRawReader`
Returns:
  Char value.
Throws:
  `BinaryObjectException` - In case of error.

#### readCharArray

    @Nullable
    public char[] readCharArray(String fieldName)
                         throws BinaryObjectException

Specified by:
  `readCharArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Char array.
Throws:
  `BinaryObjectException` - In case of error.

#### readCharArray

    @Nullable
    public char[] readCharArray()
                         throws BinaryObjectException

Specified by:
  `readCharArray` in interface `BinaryRawReader`
Returns:
  Char array.
Throws:
  `BinaryObjectException` - In case of error.

#### readInt

    public int readInt(String fieldName)
                throws BinaryObjectException

Specified by:
  `readInt` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Integer value.
Throws:
  `BinaryObjectException` - In case of error.

#### readInt

    public int readInt()
                throws BinaryObjectException

Specified by:
  `readInt` in interface `DataInput`
Specified by:
  `readInt` in interface `BinaryRawReader`
Returns:
  Integer value.
Throws:
  `BinaryObjectException` - In case of error.

#### readIntArray

    @Nullable
    public int[] readIntArray(String fieldName)
                       throws BinaryObjectException

Specified by:
  `readIntArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Integer array.
Throws:
  `BinaryObjectException` - In case of error.

#### readIntArray

    @Nullable
    public int[] readIntArray()
                       throws BinaryObjectException

Specified by:
  `readIntArray` in interface `BinaryRawReader`
Returns:
  Integer array.
Throws:
  `BinaryObjectException` - In case of error.

#### readLong

    public long readLong(String fieldName)
                  throws BinaryObjectException

Specified by:
  `readLong` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Long value.
Throws:
  `BinaryObjectException` - In case of error.

#### readLong

    public long readLong()
                  throws BinaryObjectException

Specified by:
  `readLong` in interface `DataInput`
Specified by:
  `readLong` in interface `BinaryRawReader`
Returns:
  Long value.
Throws:
  `BinaryObjectException` - In case of error.

#### readLongArray

    @Nullable
    public long[] readLongArray(String fieldName)
                         throws BinaryObjectException

Specified by:
  `readLongArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Long array.
Throws:
  `BinaryObjectException` - In case of error.

#### readLongArray

    @Nullable
    public long[] readLongArray()
                         throws BinaryObjectException

Specified by:
  `readLongArray` in interface `BinaryRawReader`
Returns:
  Long array.
Throws:
  `BinaryObjectException` - In case of error.

#### readFloat

    public float readFloat(String fieldName)
                    throws BinaryObjectException

Specified by:
  `readFloat` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Float value.
Throws:
  `BinaryObjectException` - In case of error.

#### readFloat

    public float readFloat()
                    throws BinaryObjectException

Specified by:
  `readFloat` in interface `DataInput`
Specified by:
  `readFloat` in interface `BinaryRawReader`
Returns:
  Float value.
Throws:
  `BinaryObjectException` - In case of error.

#### readFloatArray

    @Nullable
    public float[] readFloatArray(String fieldName)
                           throws BinaryObjectException

Specified by:
  `readFloatArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Float array.
Throws:
  `BinaryObjectException` - In case of error.

#### readFloatArray

    @Nullable
    public float[] readFloatArray()
                           throws BinaryObjectException

Specified by:
  `readFloatArray` in interface `BinaryRawReader`
Returns:
  Float array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDouble

    public double readDouble(String fieldName)
                      throws BinaryObjectException

Specified by:
  `readDouble` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Double value.
Throws:
  `BinaryObjectException` - In case of error.

#### readDouble

    public double readDouble()
                      throws BinaryObjectException

Specified by:
  `readDouble` in interface `DataInput`
Specified by:
  `readDouble` in interface `BinaryRawReader`
Returns:
  Double value.
Throws:
  `BinaryObjectException` - In case of error.

#### readDoubleArray

    @Nullable
    public double[] readDoubleArray(String fieldName)
                             throws BinaryObjectException

Specified by:
  `readDoubleArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Byte array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDoubleArray

    @Nullable
    public double[] readDoubleArray()
                             throws BinaryObjectException

Specified by:
  `readDoubleArray` in interface `BinaryRawReader`
Returns:
  Byte array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDecimal

    @Nullable
    public BigDecimal readDecimal(String fieldName)
                           throws BinaryObjectException

Specified by:
  `readDecimal` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Decimal value.
Throws:
  `BinaryObjectException` - In case of error.

#### readDecimal

    @Nullable
    public BigDecimal readDecimal()
                           throws BinaryObjectException

Specified by:
  `readDecimal` in interface `BinaryRawReader`
Returns:
  Decimal value.
Throws:
  `BinaryObjectException` - In case of error.

#### readDecimalArray

    @Nullable
    public BigDecimal[] readDecimalArray(String fieldName)
                                  throws BinaryObjectException

Specified by:
  `readDecimalArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Decimal array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDecimalArray

    @Nullable
    public BigDecimal[] readDecimalArray()
                                  throws BinaryObjectException

Specified by:
  `readDecimalArray` in interface `BinaryRawReader`
Returns:
  Decimal array.
Throws:
  `BinaryObjectException` - In case of error.

#### readString

    @Nullable
    public String readString(String fieldName)
                      throws BinaryObjectException

Specified by:
  `readString` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  String value.
Throws:
  `BinaryObjectException` - In case of error.

#### readString

    @Nullable
    public String readString()
                      throws BinaryObjectException

Specified by:
  `readString` in interface `BinaryRawReader`
Returns:
  String value.
Throws:
  `BinaryObjectException` - In case of error.

#### readStringArray

    @Nullable
    public String[] readStringArray(String fieldName)
                             throws BinaryObjectException

Specified by:
  `readStringArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  String array.
Throws:
  `BinaryObjectException` - In case of error.

#### readStringArray

    @Nullable
    public String[] readStringArray()
                             throws BinaryObjectException

Specified by:
  `readStringArray` in interface `BinaryRawReader`
Returns:
  String array.
Throws:
  `BinaryObjectException` - In case of error.

#### readUuid

    @Nullable
    public UUID readUuid(String fieldName)
                  throws BinaryObjectException

Specified by:
  `readUuid` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  UUID.
Throws:
  `BinaryObjectException` - In case of error.

#### readUuid

    @Nullable
    public UUID readUuid()
                  throws BinaryObjectException

Specified by:
  `readUuid` in interface `BinaryRawReader`
Returns:
  UUID.
Throws:
  `BinaryObjectException` - In case of error.

#### readUuidArray

    @Nullable
    public UUID[] readUuidArray(String fieldName)
                         throws BinaryObjectException

Specified by:
  `readUuidArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  UUID array.
Throws:
  `BinaryObjectException` - In case of error.

#### readUuidArray

    @Nullable
    public UUID[] readUuidArray()
                         throws BinaryObjectException

Specified by:
  `readUuidArray` in interface `BinaryRawReader`
Returns:
  UUID array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDate

    @Nullable
    public Date readDate(String fieldName)
                  throws BinaryObjectException

Specified by:
  `readDate` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Date.
Throws:
  `BinaryObjectException` - In case of error.

#### readDate

    @Nullable
    public Date readDate()
                  throws BinaryObjectException

Specified by:
  `readDate` in interface `BinaryRawReader`
Returns:
  Date.
Throws:
  `BinaryObjectException` - In case of error.

#### readDateArray

    @Nullable
    public Date[] readDateArray(String fieldName)
                         throws BinaryObjectException

Specified by:
  `readDateArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Date array.
Throws:
  `BinaryObjectException` - In case of error.

#### readDateArray

    @Nullable
    public Date[] readDateArray()
                         throws BinaryObjectException

Specified by:
  `readDateArray` in interface `BinaryRawReader`
Returns:
  Date array.
Throws:
  `BinaryObjectException` - In case of error.

#### readTimestamp

    @Nullable
    public Timestamp readTimestamp(String fieldName)
                            throws BinaryObjectException

Specified by:
  `readTimestamp` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Timestamp.
Throws:
  `BinaryObjectException` - In case of error.

#### readTimestamp

    @Nullable
    public Timestamp readTimestamp()
                            throws BinaryObjectException

Specified by:
  `readTimestamp` in interface `BinaryRawReader`
Returns:
  Timestamp.
Throws:
  `BinaryObjectException` - In case of error.

#### readTimestampArray

    @Nullable
    public Timestamp[] readTimestampArray(String fieldName)
                                   throws BinaryObjectException

Specified by:
  `readTimestampArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Timestamp array.
Throws:
  `BinaryObjectException` - In case of error.

#### readTimestampArray

    @Nullable
    public Timestamp[] readTimestampArray()
                                   throws BinaryObjectException

Specified by:
  `readTimestampArray` in interface `BinaryRawReader`
Returns:
  Timestamp array.
Throws:
  `BinaryObjectException` - In case of error.

#### readObject

    @Nullable
    public <T> T readObject(String fieldName)
                 throws BinaryObjectException

Specified by:
  `readObject` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Object.
Throws:
  `BinaryObjectException` - In case of error.

#### readObject

    public Object readObject()
                      throws BinaryObjectException

Specified by:
  `readObject` in interface `ObjectInput`
Specified by:
  `readObject` in interface `BinaryRawReader`
Returns:
  Object.
Throws:
  `BinaryObjectException` - In case of error.

#### readObjectDetached

    @Nullable
    public Object readObjectDetached()
                              throws BinaryObjectException

Specified by:
  `readObjectDetached` in interface `BinaryRawReaderEx`
Returns:
  Object.
Throws:
  `BinaryObjectException` - In case of error.

#### readObjectArray

    @Nullable
    public Object[] readObjectArray(String fieldName)
                             throws BinaryObjectException

Specified by:
  `readObjectArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Object array.
Throws:
  `BinaryObjectException` - In case of error.

#### readObjectArray

    @Nullable
    public Object[] readObjectArray()
                             throws BinaryObjectException

Specified by:
  `readObjectArray` in interface `BinaryRawReader`
Returns:
  Object array.
Throws:
  `BinaryObjectException` - In case of error.

#### readEnum

    @Nullable
    public <T extends Enum<?>> T readEnum(String fieldName)
                            throws BinaryObjectException

Specified by:
  `readEnum` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Value.
Throws:
  `BinaryObjectException` - In case of error.

#### readEnum

    @Nullable
    public <T extends Enum<?>> T readEnum()
                            throws BinaryObjectException

Specified by:
  `readEnum` in interface `BinaryRawReader`
Returns:
  Value.
Throws:
  `BinaryObjectException` - In case of error.

#### readEnumArray

    @Nullable
    public <T extends Enum<?>> T[] readEnumArray(String fieldName)
                                   throws BinaryObjectException

Specified by:
  `readEnumArray` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Value.
Throws:
  `BinaryObjectException` - In case of error.

#### readEnumArray

    @Nullable
    public <T extends Enum<?>> T[] readEnumArray()
                                   throws BinaryObjectException

Specified by:
  `readEnumArray` in interface `BinaryRawReader`
Returns:
  Value.
Throws:
  `BinaryObjectException` - In case of error.

#### readCollection

    @Nullable
    public <T> Collection<T> readCollection(String fieldName)
                                 throws BinaryObjectException

Specified by:
  `readCollection` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Collection.
Throws:
  `BinaryObjectException` - In case of error.

#### readCollection

    @Nullable
    public <T> Collection<T> readCollection(String fieldName,
                                            BinaryCollectionFactory<T> factory)
                                 throws BinaryObjectException

Specified by:
  `readCollection` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
  `factory` - Collection factory.
Returns:
  Collection.
Throws:
  `BinaryObjectException` - In case of error.

#### readCollection

    @Nullable
    public <T> Collection<T> readCollection()
                                 throws BinaryObjectException

Specified by:
  `readCollection` in interface `BinaryRawReader`
Returns:
  Collection.
Throws:
  `BinaryObjectException` - In case of error.

#### readCollection

    @Nullable
    public <T> Collection<T> readCollection(BinaryCollectionFactory<T> factory)
                                 throws BinaryObjectException

Specified by:
  `readCollection` in interface `BinaryRawReader`
Parameters:
  `factory` - Collection factory.
Returns:
  Collection.
Throws:
  `BinaryObjectException` - In case of error.

#### readMap

    @Nullable
    public <K,V> Map<K,V> readMap(String fieldName)
                     throws BinaryObjectException

Specified by:
  `readMap` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
Returns:
  Map.
Throws:
  `BinaryObjectException` - In case of error.

#### readMap

    @Nullable
    public <K,V> Map<K,V> readMap(String fieldName,
                                  BinaryMapFactory<K,V> factory)
                     throws BinaryObjectException

Specified by:
  `readMap` in interface `BinaryReader`
Parameters:
  `fieldName` - Field name.
  `factory` - Map factory.
Returns:
  Map.
Throws:
  `BinaryObjectException` - In case of error.

#### readMap

    @Nullable
    public <K,V> Map<K,V> readMap()
                     throws BinaryObjectException

Specified by:
  `readMap` in interface `BinaryRawReader`
Returns:
  Map.
Throws:
  `BinaryObjectException` - In case of error.

#### readMap

    @Nullable
    public <K,V> Map<K,V> readMap(BinaryMapFactory<K,V> factory)
                     throws BinaryObjectException

Specified by:
  `readMap` in interface `BinaryRawReader`
Parameters:
  `factory` - Map factory.
Returns:
  Map.
Throws:
  `BinaryObjectException` - In case of error.

#### rawReader

    public BinaryRawReader rawReader()

Gets raw reader. Raw reader does not use field name hash codes, therefore, making the format even more compact. However, if the raw reader is used, dynamic structure changes to the binary objects are not supported.

Specified by:
  `rawReader` in interface `BinaryReader`
Returns:
  Raw reader.

#### getOrCreateSchema

    public BinarySchema getOrCreateSchema()

Get or create object schema.

Returns:
  Schema.

#### findFieldByName

    public boolean findFieldByName(String name)

Try finding the field by name.

Parameters:
  `name` - Field name.
Returns:
  Offset.

#### readUnsignedByte

    public int readUnsignedByte()
                         throws IOException

Specified by:
  `readUnsignedByte` in interface `DataInput`
Throws:
  `IOException`

#### readUnsignedShort

    public int readUnsignedShort()
                          throws IOException

Specified by:
  `readUnsignedShort` in interface `DataInput`
Throws:
  `IOException`

#### readLine

    public String readLine()
                    throws IOException

Specified by:
  `readLine` in interface `DataInput`
Throws:
  `IOException`

#### readUTF

    @NotNull
    public String readUTF()
                   throws IOException

Specified by:
  `readUTF` in interface `DataInput`
Throws:
  `IOException`

#### readFully

    public void readFully(byte[] b)
                   throws IOException

Specified by:
  `readFully` in interface `DataInput`
Throws:
  `IOException`

#### readFully

    public void readFully(byte[] b,
                 int off,
                 int len)
                   throws IOException

Specified by:
  `readFully` in interface `DataInput`
Throws:
  `IOException`

#### skipBytes

    public int skipBytes(int n)
                  throws IOException

Specified by:
  `skipBytes` in interface `DataInput`
Throws:
  `IOException`

#### read

    public int read()
             throws IOException

Specified by:
  `read` in interface `ObjectInput`
Throws:
  `IOException`

#### read

    public int read(byte[] b)
             throws IOException

Specified by:
  `read` in interface `ObjectInput`
Throws:
  `IOException`

#### read

    public int read(byte[] b,
           int off,
           int len)
             throws IOException

Specified by:
  `read` in interface `ObjectInput`
Throws:
  `IOException`

#### skip

    public long skip(long n)
              throws IOException

Specified by:
  `skip` in interface `ObjectInput`
Throws:
  `IOException`

#### available

    public int available()
                  throws IOException

Specified by:
  `available` in interface `ObjectInput`
Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `ObjectInput`
Specified by:
  `close` in interface `AutoCloseable`
Throws:
  `IOException`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.6.0
Release Date | : May 18 2016